﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DAL;
using Domain;

namespace ConsoleApp
{
    public static class PersonLogic
    {
        public static void CommandPersonRead(AppDbContext db)
        {
            var p = db.Persons.FirstOrDefault(x => x.FirstName.ToLower() == "andres");
            if (p == null)
            {
                Console.WriteLine("No persons in db!");
                return;
            }

            Console.WriteLine(p);
            foreach (var pContact in p.Contacts)
            {
                Console.WriteLine($"    {pContact}");
            }
        }

        public static void CommandPersonDelete(AppDbContext db)
        {
            if (!db.Persons.Any())
            {
                Console.WriteLine("List is empty!");
                return;
            }

            CommandPersonList(db);
            Console.WriteLine("Give the ID of record to delete (0 to cancel):");
            var command = Console.ReadLine().Trim();
            if (command != "0")
            {
                //var recordNoDoDelete = int.Parse(command) - 1;
                var recordIdDoDelete = 0;
                if (int.TryParse(command, out recordIdDoDelete))
                {
                    // null or record from db
                    var person = db.Persons.FirstOrDefault(
                        p => p.PersonId == recordIdDoDelete);
                    if (person != null)
                    {
                        db.Persons.Remove(person);
                        db.SaveChanges();
                    }
                    else
                    {
                        Console.WriteLine("ID was not found in DB!");
                    }
                }
                else
                {
                    Console.WriteLine("Please enter an number!");
                }
            }

        }

        public static void CommandPersonCreate(AppDbContext db)
        {
            Console.WriteLine();
            Console.Write("First name:");
            var firstName = Console.ReadLine();
            Console.Write("Last name:");
            var lastName = Console.ReadLine();

            try
            {
                db.Persons.Add(new Person()
                {
                    FirstName = firstName,
                    LastName = lastName
                });
                Console.WriteLine("Person added. Count in db: " + db.Persons.Count());
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error during insertion! Message:" + ex.Message);
            }

            Console.WriteLine();
        }

        public static void CommandPersonList(AppDbContext db)
        {
            Console.WriteLine();
            Console.WriteLine("Count: " + db.Persons.Count());
            var counter = 1;
            foreach (var dbPerson in db.Persons)
            {
                Console.WriteLine($"No {counter} - {dbPerson}");
                counter++;
            }
        }
    }
}
